unit Command;
{$WARN Symbol_Platform off}

interface

uses
Windows, SysUtils;

function ServiceCommand(Command: string;
sError, SOutput, SInput: THandle): THandle;
procedure InlineCommand(Command: string;
Visible: Boolean = True;
sError: THandle = High(THandle);
sOutput: THandle = High(THandle);
sInput: THandle = High(THandle));
                                procedure ForkCommand(Command: string);

const
Inheritable: TSecurityAttributes = (
nLength: 0;
lpSecurityDescriptor: nil;
bInheritHandle: True);

implementation

         procedure GeneralExec(Command: string;
Visible: Boolean;
sError, SOutput, SInput: THandle;
WaitFor: Boolean;
Result: PHandle);
var
SI: TStartupInfo;
PI: TProcessInformation;
Redirect: Boolean;
procedure ComHan(A, B: THandle);
begin
if (A = High(A)) and (B = High(A)) then
Exit;
Redirect := True;
Assert(A <> B);
end;
begin
Redirect := False;
ComHan(sInput, sOutput);
ComHan(sOutput, sError);
ComHan(sInput, sError);
if Redirect or (not Visible) then
if Result = nil then
Assert(WaitFor);
if WaitFor then
Assert(Result = nil);
FillChar(SI, SizeOf(SI), 0);
UniqueString(Command);
with SI do begin
cb := SizeOf(SI);
if not Visible then begin
dwFlags := dwFlags or STARTF_UseShowWindow;
wShowWindow := SW_HIDE;
end;
if Redirect then begin
dwFlags := dwFlags or StartF_UseStdHandles;
hStdInput := sInput;
hStdOutput := sOutput;
hStdError := sError;
end;
end;
Command := Command + #0;
FillChar(PI, SizeOf(PI), 0);
Win32Check(CreateProcess(nil, @Command[1],
nil, nil, Redirect, 0,
nil, nil, SI, PI));
with PI do try
if WaitFor then
Assert(WaitForSingleObject(hProcess, INFINITE) =
Wait_Object_0);
finally
Win32Check(CloseHandle(hThread));
if Result = nil then
Win32Check(CloseHandle(hProcess))
else
Result^ := hProcess;
end;
end;

function ServiceCommand;
begin
GeneralExec(Command, False, sError, sOutput, sInput,
False, @Result);
end;

procedure InlineCommand;
begin
GeneralExec(Command, Visible,
sError, SOutput, sInput, True, nil);
end;

procedure ForkCommand;
begin
GeneralExec(Command, False,
High(Thandle), High(Thandle), High(Thandle), False, nil);
end;

end.
