unit ItemsUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileUnit, Buttons, ExtCtrls, StdCtrls;

type
TCategoryFlag = (cfExtras, cfKitchen, cfBar, cfSecondary);
{$i Items.inc}
  TItemsForm = class(TFileForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
Items: TItems;
  end;

var
  ItemsForm: TItemsForm;

function CentsToStr(Cents: Integer): string;

implementation

{$R *.dfm}

procedure TItemsForm.FormCreate(Sender: TObject);
begin
Persistent[SizeOf(Items)] := @Items;
Load; // Call before inherited to set to manual mode.
  inherited;
end;

function CentsToStr;
var D: Double;
begin
D := Cents / 100;
Result := Format('%f:2', [d]);
end;

end.
 