unit TermUnit;

{$IoChecks Off}

interface

uses Windows, Classes, SysUtils;

procedure Term(Msg: ShortString);
procedure CheckThread;

implementation

var ErrorFile:  Text;

procedure Term;
begin
Rewrite(ErrorFile);
WriteLn(ErrorFile, Msg);
Close(ErrorFile);
                TerminateProcess( GetCurrentProcess, 1);
Halt(1);
end;

procedure CheckThread;
begin
if MainThreadID<> GetCurrentThreadID then
Term('Cannot be outside main thread.');
end;

initialization
Assign(ErrorFile, ExtractFilePath(
ParamStr(0)) + 'LastError.log'); 
end.
