unit ActionPOS9;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, RegistryFPC, TemplateUnit, AppEvnts, ImgList;

type
  TParentForm = class(TTemplate)
    Bar: TMainMenu;
    Sales1: TMenuItem;
    Inventory1: TMenuItem;
    N1: TMenuItem;
    ransactionHistory1: TMenuItem;
    GoodsReceivedNotes1: TMenuItem;
    Whichmodulewouldliketoworkwith1: TMenuItem;
    Reports1: TMenuItem;
    GenerateinMicrosoftExcel1: TMenuItem;
    SaveasAdobePDF1: TMenuItem;
    ExporttoOpenOfficecompatible1: TMenuItem;
    ShowinWebBrowser1: TMenuItem;
    ClosedPurchaseOrders1: TMenuItem;
    SetupandMasterFiles1: TMenuItem;
    Users1: TMenuItem;
    Inventory2: TMenuItem;
    ReceiptGeneration1: TMenuItem;
    Security1: TMenuItem;
    Suppliers1: TMenuItem;
    StoreDetails1: TMenuItem;
    VAT1: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    PurchaseOrders1: TMenuItem;
    ImageList1: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure Sales1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ApplicationEvents1Idle(Sender: TObject; var Done: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Whichmodulewouldliketoworkwith1Click(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
  private
    { Private declarations }
FCreated: Boolean;
FReg: TRegistry;
oWS: TWindowState;
oLeft: Integer;
procedure Install;
  public
    { Public declarations }
procedure SwapVectors;
  end;

var
  ParentForm: TParentForm;

implementation

uses Home, LoginUnit, MasterUnit, MultipleUnit, TransactionUnit, FileActionUnit, Contact;

{$R *.dfm}

// It is OK to delete this line, but then you must include all the .inc files in the same directory as your distributed executable:
{$R IncAll.res}

procedure TParentForm.FormCreate(Sender: TObject);
var I: Integer;
begin
if  FileExists(ChangeFileExt(ParamStr(0), '.dpr')) then begin
for I := 0 to Pred(Bar.Items.Count) do
Bar.Items[i].ImageIndex := -1;
end else Install;
FReg := TRegistry.Create;
FReg.OpenKey('software', false);
FReg.OpenKey(Application.Title, True);
if FReg.ValueExists('Max') then
if FReg.ReadBool('Max') then
if WindowState = wsNormal then
WindowState := wsMaximized;
FCreated := True;
end;

procedure TParentForm.Sales1Click(Sender: TObject);
begin
LoginForm.Show;
oWS := WindowState;
WindowState := wsNormal;
oLeft := Left;
Left := -Width;
Enabled := False;
end;

procedure TParentForm.SwapVectors;
begin
Enabled := True;
Left := oLeft;
WindowState := oWS;
end;

procedure TParentForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FReg.WriteBool('Max', WindowState = wsMaximized);
FreeAndNil(Freg);
end;

procedure TParentForm.ApplicationEvents1Idle(Sender: TObject;
  var Done: Boolean);
var I: Byte;
begin
  inherited;
Done := True;
if not FCreated then Exit;
with Application do
     for I := 0 to Pred(ComponentCount) do
if Components[i] is TForm then
with Components[i] as TTemplate do
ProcessIdle;
end;

procedure TParentForm.FormShow(Sender: TObject);
var Targ, Item: TMenuItem;
I: Word;
Value, Serial: string;
X, Y: Integer;
begin
  inherited;
with Application do
for I := 0 to Pred(ComponentCount) do begin
Targ := nil;
if Components[i] is TMaster then
Targ := SetupandMasterFiles1
else if Components[i] is TTransaction then
Targ := ransactionHistory1;
if Assigned(Targ) then begin
with Components[i] as TForm do
if ClassParent = TMultiple  then Continue;
Item := TMenuItem.Create(nil) ;
with Components[I] as TMultiple do begin
Item.Caption := Caption;
Item.OnClick := MenuClick;
end;
Targ.Add(Item);
end; end;
with TRegistry.Create do try
RootKey := HKey_Local_Machine;
if OpenKeyReadOnly('WinE') then begin
CloseKey;
OpenKey('software', True);
Value := ExtractFileName(ParamStr(0));
if ValueExists(Value) then
Serial := ReadString(Value)
else Serial := InputBox('Unlock Software',
'Please enter your 4-digit support serial number. If you do not have one, you can purchase one from ' + Email, '');
X := 0;
for I := 1 to Length(Serial) do
if TryStrToInt(Serial[i], Y) then
X := (X + Y) mod 10;
if X <> 0 then
CriticalStop('The serial number which you have entered is invalid.');
     WriteString(Value, Serial);
                                end ;
Caption := Application.Title;
finally Free; end;
end;

procedure TParentForm.Whichmodulewouldliketoworkwith1Click(
  Sender: TObject);
begin
(Sender as TMenuItem).Enabled := False;
FileAction('http://www.' + Application.Title
+ '/modules.html', '', True);
end;

procedure TParentForm.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
const Max_Good_Digits = 4;
var S: string;
I, FirstPos, LastPos: Integer;
Broken: Boolean;
begin
if (E is EExternal) or
(E is EStreamError)  then begin
if E is EAccessviolation then begin
S := E.Message;
FirstPos := 0;
LastPos := 0;
Broken := False;
for I := Length(S) downto 1 do
case UpCase(S[i]) of
'0'..'9', 'A'..'Z': begin
if Broken then Continue;
                 if LastPos = 0 then
LastPos := I;
FirstPos := I;
end;
else
if LastPos > 0 then Broken := True;
end;
while True do begin
if FirstPos = LastPos then Break;
if S[FirstPos] <> '0' then Break;
Inc(FirstPos);
end;
if Succ(LastPos - FirstPos) <= Max_Good_Digits then Exit;
                                                       end;
TerminateProcess(GetCurrentProcess, 1);
Application.Terminate;
end;
end;

procedure TParentForm.Install;
const ValName = 'InstallTo';
var EXEName, DestDir: string;
Src: TStream;
begin try
                    EXEName := 'Start ' + Application.Title + '.EXE';
if  SameText(ExtractFileName(
Application.ExeName), ExeName) then Exit;
DestDir := 'C:\' + Application.Title + '\';
with TRegistry.Create do try
OpenKey('software', true);
openKey(Application.Title, true);
if ValueExists(ValName) then
DestDir := ReadString(ValName);
if InputQuery(Application.Title,
'Install To:', DestDir) then begin
DestDir := IncludeTrailingPathDelimiter(DestDir);
ForceDirectories(DestDir + 'database' + PathDelim);
Src := TFileStream.Create(Application.ExeName, fmOpenRead or fmShareDenyNone); try
with TFileStream.Create(DestDir + ExeName, fmCreate) do try
CopyFrom(Src, 0);
finally Free; end;
finally FreeAndNil(Src); end;
WriteString(ValName, DestDir);
FileAction(DestDir, '', True);
CoolMB('Installation successful.',
Application.Title, Mb_IconInformation); 
end;
finally Free; end;
Application.Terminate;
Halt;
except on E: Exception do
CriticalStop(E.Message);
end; end;

end.
