unit CentroidUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TemplateUnit, Math, StdCtrls;

type
  TCentroid = class(TTemplate)
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
procedure GhostLabs(P: TWinCOntrol);
protected
function StripCap(Cap: string): string;
procedure BadCall(Msg: string);
  public
    { Public declarations }
  end;

var
  Centroid: TCentroid;

implementation

uses BadCallUnit;

{$R *.dfm}

procedure TCentroid.BadCall(Msg: string);
begin
with BadCallForm do begin
MessagePanel.Caption := Msg;
ShowModal;
end;
Abort;
end;

procedure TCentroid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
Application.Terminate;
end;

function TCentroid.StripCap(Cap: string): string;
procedure DelAll(Sub: string);
var P: Word;
begin
repeat
P := Pos(Sub, Cap);
if P = 0 then Break;
Delete(Cap, P, Length(Sub));
until False;
end;
begin
UniqueString(Cap);
            DelAll(sLineBreak);
DelAll('&');
Result := Cap;
end;

procedure TCentroid.FormHide(Sender: TObject);
var I: Integer;
Deleted: Boolean;
begin
  inherited;
               repeat
Deleted := False;
for I := 0 to Pred(ControlCount) do
if Controls[i].Name = '' then begin
Controls[i].Free;
Deleted := True;
Break; end;
until not Deleted;
end;

procedure TCentroid.FormCreate(Sender: TObject);
begin
  inherited;
GhostLabs(Self);
SetLength(Columns, 1);
with Columns[0] do begin
Left := 0;
Right := ClientWidth;
Initial := clInactiveCaption;
Final := clActiveCaption;
end;
end;

procedure TCentroid.GhostLabs(P: TWinCOntrol);
var I: Integer;
begin
with P do
               for I := 0 to Pred(ControlCount) do
if Controls[i] is TWinControl then
GhostLabs(Controls[i] as TWInControl)
else if COntrols[i] is TLabel then
with Controls[i] as TLabel do
Transparent := True;
end;

end.
