unit DiscardUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, CentroidUnit, ComCtrls, StdCtrls, Buttons, ExtCtrls;

type
  TDiscardForm = class(TCentroid)
    StatusLab: TLabel;
    Animate1: TAnimate;
    StopBtn: TSpeedButton;
    ModalTimer: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure ModalTimerTimer(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DiscardForm: TDiscardForm;

implementation

{$R *.dfm}

procedure TDiscardForm.FormCreate(Sender: TObject);
begin
  inherited;
with Columns[0] do begin
Initial := clMaroon;
Final := clRed;
end;
end;

procedure TDiscardForm.StopBtnClick(Sender: TObject);
begin
  inherited;
ModalResult := mrAbort;
end;

procedure TDiscardForm.ModalTimerTimer(Sender: TObject);
begin
  inherited;
Close;
end;

procedure TDiscardForm.FormShow(Sender: TObject);
begin
  inherited;
ModalTimer.Enabled := True;
Animate1.Active := True;
end;

procedure TDiscardForm.FormHide(Sender: TObject);
begin
  inherited;
Animate1.Active := False;
ModalTimer.ENabled := False;
end;

procedure TDiscardForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
  inherited;
if Ord(Key) = VK_Escape then begin
Key := #0;
if StopBtn.Visible then
StopBtn.Click;
end;
end;

end.
