unit JavaCheck;

{$WArn Symbol_Platform off}

interface

uses
Windows, Command, Classes, SysUtils, SHFolder, Profile;

function Java13: Boolean;

implementation

function Java13;
const
FILE_APPEND_DATA = $0004;
ClassName = 'HelloWorld13';
Expected = 'Hello World';
var
hOut, hErr: THandle;
function TempHandle: THandle;
begin
Result := CreateFile(PChar(NewTemp), GENERIC_READ or GENERIC_WRITE,
0, @Inheritable, CREATE_NEW,
File_Attribute_Temporary or FILE_FlaG_Delete_On_Close,
iNValid_Handle_Value);
end;
var
Buf: array[0..Length(Expected) * 2] of AnsiChar;
begin
try
Assert(FileExists(ClassName + '.class'));
hOut := TempHandle;
Win32Check(Invalid_Handle_Value <> hOut);
hErr := TempHandle;
try
                                      Win32Check(Invalid_Handle_Value <> hErr);
InlineCommand('java ' + ClassName, False,
hErr, hOut);
FillChar(Buf, SizeOf(Buf), 0);
FileSeek(hOut, 0, 0);
FileRead(hOut, Buf, SizeOf(Buf) - SizeOf(AnsiChar));
Result :=  Pos(LowerCase(Expected),
LowerCase(PAnsiChar(@Buf[0]))) > 0;
finally
FileClose(hErr);
FileClose(hOut);
end;
except
Result := False;
end;
   end;

end.
