unit SessInfo;

{$Warn Symbol_Platform off}

interface

uses Windows, Registry, SysUtils;

function HasRights: Boolean;
function GetUserName: string;
function GetComputerName: string;

implementation

type TPropFunc = function (lpBuffer: PChar; var nSize: DWORD): BOOL; stdcall;

function GetProperty(PropFunc: TPropFunc): string;
var
Count: DWord;
begin
Result := StringOfChar(#0, 256);
Count := 200;
Win32Check(PropFunc(@Result[1], Count));
Result := Trim(Result);
end;

function HasRights;
begin
with TRegistry.Create do try
RootKey := HKey_Local_Machine;
Result := OpenKey('Software', False);
finally Free; end;
end;

function GetComputerName;
begin
Result := GetProperty(Windows.GetComputerName);
end;

function GetUserName;
begin
Result := GetProperty(WIndows.GetUserName);
end;

end.
