unit Token;

interface

uses
SysUtils;

type
TTokenResult = array of string;

function GetToken( TC, QC: Char; S: string; AllowBlanks: Boolean): TTokenResult;
function SetToken(TC, QC, SC: Char; Vals: array of string): string;

implementation

function GetToken;
procedure TrimArray;
var P: PString;
begin
if AllowBlanks then Exit;
if Length(Result) = 0 then Exit;
               P := @Result[ High(Result)];
P^ := Trim( P^);
if P^ = '' then
SetLength(Result, Pred( Length(Result)));
end;
var
I: Integer;
Quoted: Boolean;
begin
Quoted := False;
S := TC + s;
for I := 1 to Length(S) do
if QC = S[i] then
Quoted := not Quoted
else if (not Quoted ) and
(S[I] = TC) then begin
TrimArray;
SetLength(Result, Succ(Length(Result)))
end                                        else
Result[High(Result)] := Result[High(Result)] + S[i];
TrimArray;
if Quoted then
Result := nil;
end;

function SetToken;
var
I: Integer;
begin
Result := '';
for I := 0 to High(Vals) do
             Result := Result + Vals[i] + TC;
end;

end.
